;##################################################################
; DIALOGAPP
;##################################################################

IDD_DLG1	equ		1000

CoInvoke(%pInterface,%Method,%0,%1,%2,%3,%4,%5,%6,%7,%8,%9) = \
	#IF ARGCOUNT = 12 \
		push %9 \
	#ENDIF \
	#IF ARGCOUNT > 10 \
		push %8 \
	#ENDIF \
	#IF ARGCOUNT > 9 \
		push %7 \
	#ENDIF \
	#IF ARGCOUNT > 8 \
		push %6 \
	#ENDIF \
	#IF ARGCOUNT > 7 \
		push %5 \
	#ENDIF \
	#IF ARGCOUNT > 6 \
		push %4 \
	#ENDIF \
	#IF ARGCOUNT > 5 \
		push %3 \
	#ENDIF \
	#IF ARGCOUNT > 4 \
		push %2 \
	#ENDIF \
	#IF ARGCOUNT > 3 \
		push %1 \
	#ENDIF \
	#IF ARGCOUNT > 2 \
		push %0 \
	#ENDIF \
	push [%pInterface] \
	mov eax, [%pInterface] \
	mov eax,[eax] \
	add eax, %Method \
	call [eax]

#define GUID_IID_ITaskbarList <0x56fdf342,0xfd6d,0x11d0,0x95,0x8a,0x0,0x60,0x97,0xc9,0xa0,0x90>
#define GUID_CLSID_TaskbarList <0x56fdf344,0xfd6d,0x11d0,0x95,0x8a,0x0,0x60,0x97,0xc9,0xa0,0x90>

#define CLSCTX_INPROC_SERVER 1
#define NULL 0
#Define TRUE 1
#Define FALSE 0
#define WM_INITDIALOG  0x0110
#define WM_COMMAND  0x0111
#define WM_CLOSE  0x0010

GUID STRUCT
	Data1	dd
	Data2	dw
	Data3	dw
	Data4	db
			db
			db
			db
			db
			db
			db
			db
ENDS

Unknown STRUCT
	QueryInterface			DD		?
	AddRef					DD		?
	Release					DD		?
ENDS

ITaskbarList STRUCT
	IUnknown				Unknown		<>
	
	HrInit					DD	?
	AddTab					DD	?
	DeleteTab				DD	?
	ActivateTab				DD	?
	SetActiveAlt			DD	?
ENDS

DATA SECTION
	hInstance			DD		?

	CLSID_ITaskbarList	GUID	GUID_CLSID_TaskbarList
	IID_ITaskbarList	GUID	GUID_IID_ITaskbarList

CODE SECTION

Start:
	invoke GetModuleHandleA, 0
	mov [hInstance],eax
	invoke CoInitialize,NULL
	invoke InitCommonControls
	invoke DialogBoxParamA,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke CoUninitialize
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne >.WM_COMMAND
		
		jmp >.EXIT

	.WM_COMMAND
	cmp eax,WM_COMMAND
	jne >.WM_CLOSE
		mov eax,[wParam]
		and eax,0xFFFF
		cmp eax, 1001
		jne >
			invoke ShowTab,[hwnd],FALSE
			jmp >.EXIT
		:
		cmp eax,1002
		jne >.EXIT
			invoke ShowTab,[hwnd],TRUE
			jmp >.EXIT

	.WM_CLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

ShowTab FRAME hWnd,fShow
	LOCAL ptb		:D

	invoke CoCreateInstance,offset CLSID_ITaskbarList, NULL, CLSCTX_INPROC_SERVER, offset IID_ITaskbarList, offset ptb
	test eax,eax
	jz >
		
		mov eax,-1
		ret
	:

	CoInvoke(ptb,ITaskbarList.HrInit)
	test eax,eax
	jz >
		CoInvoke(ptb,ITaskbarList.IUnknown.Release)
		mov eax,-1
		ret
	:

	cmp D[fShow],0
	je >
		CoInvoke(ptb,ITaskbarList.AddTab,[hWnd])
		jmp >1
	:
		CoInvoke(ptb,ITaskbarList.DeleteTab,[hWnd])
	1:
	test eax,eax
	jz >
		CoInvoke(ptb,ITaskbarList.IUnknown.Release)
		mov eax,-1
		ret
	:

	CoInvoke(ptb,ITaskbarList.IUnknown.Release)

	xor eax,eax

	ret
ENDF

;#########################################################################
